#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <string.h> /* za strcpy tj. kopiranje znakovnog niza*/
#include <stdlib.h> /* za malloc. */
#include <windows.h>

#define STR_LEN 20

int main(void) {

	/* Define the structure. */
	struct student_grade {
		char first_name[STR_LEN];
		char last_name[STR_LEN];
		float grade;
		struct student_grade *next;
	};

	/* typedef za alijas. */

	typedef struct student_grade sg;

	/* Kreiraj 3 strukture. Treca je za oslobadanje memorije na kraju.*/
	sg *last = NULL;
	sg *neww = NULL;
	sg *temp = NULL;

	int num; /* za provjeru unosa. */

			 /* pomocni float za provjeru upisa. */
	float g; /* ocjena */

			 /* pomocni znakovni nizovi za provjeru upisa */
	char fn[STR_LEN], ln[STR_LEN];

	/* Upit za korisnika. */
	printf("Upisi ime, prezime studenta i njegovu prosjecnu ocjenu. Upisi 0 0 0 za izlaz.\n(Ime Prezime ##.#): ");

	/* Unos podataka. */
	num = scanf("%11s %11s %f", fn, ln, &g);

	/* beskonacna petlja */
	while (fn[0] != '0') {

		/* Provjera unosa. */
		if (num == 3) { //ako je unos ispravan

			neww = (sg *)malloc(sizeof(sg));

			/* eventualno provjeriti da li je alociranje uspjesno - ovdje nismo. */

			strcpy(neww->first_name, fn);
			strcpy(neww->last_name, ln);
			neww->grade = g;
			neww->next = last;
			last = neww;

		}
		else {
			printf("Podaci nisu u ispravnom formatu.\n\n");
			break; //prekid
		}

		/* Upit za korisnika. */
		printf("Upisi ime, prezime studenta i njegovu prosjecnu ocjenu. Upisi 0 0 0 za izlaz.\n(Ime Prezime ##.#): ");

		/* Unos. */
		num = scanf("%11s %11s %f", fn, ln, &g);

	} /* kraj while petlje. */

	neww = last; /* pocinjemo s kraja liste (u odnosu na upis). */

	while (neww != NULL) { /* kraj kad pokazivac pokazuje na NULL. */

		printf("%s %s %0.1f\n", neww->first_name, neww->last_name, neww->grade);
		temp = neww->next;
		free(neww); //ako smo sigurni da vise ne trebamo podatke, u suprotnom naravno ne oslobadamo memoriju
		neww = temp;

	}

	system("pause.exe");
	return 0;
}