// string konstruktor
#include <iostream>
#include <string>
#include <windows.h>
using namespace std;

int main(void)
{
	string s0("Initial string");
	
	// konstruktori kao u prethodnim primjerima:
	string s1;
	string s2(s0);
	string s3 = string(s0, 8, 3);
	string s4("Another character sequence");
	string s5("A character sequence", 6);
	string s6a(10, 'x'); //ili string s6a=string(10,'x');
	string s6b(10, 42);      // 42 je ASCII kod za '*'
	string s7(s0.begin(), s0.begin() + 7);
	char c = 'a';

	cout << "s1: " << s1 << endl;
	cout << "s2: " << s2 << endl;
	cout << "s3: " << s3 << endl;
	cout << "s4: " << s4 << endl;
	cout << "s5: " << s5 << endl;
	cout << "s6a: " << s6a << endl;
	cout << "s6b: " << s6b << endl;
	cout << "s7: " << s7 << endl;
	cout << "s0+s3: " << s0+s3 << endl;
	cout << "Umetanje s3 iza 2 mjesta stringa s0: " << string(s0.begin(), s0.begin() + 2) + s3 + string(s0.begin() + 2, s0.end()) << endl;
	cout << "Umetanje s3 iza 2 mjesta stringa s0 2 nacin: " << string(s0, 0, 2) + s3 + string(s0, 2, s0.length()-2) << endl;

	cout << "s0.length() daje: " << s0.length() << endl;
	s0.push_back(c);
	cout << "Nakon izvodenja s0.push_back(c), s0 daje: " << s0 << endl;
	s0.pop_back();
	cout << "Nakon izvodenja s0.pop_back(), s0 daje: " << s0 << endl;
	cout << "s0.append(s0) daje: " << s0.append(s0) << endl;
	cout << "s0.at(0) daje: " << s0.at(0) << endl;
	cout << "s0[0] daje: " << s0[0] << endl;
	cout << "s0.front() daje: " << s0.front() << endl;
	cout << "s0.back() daje: " << s0.back() << endl;

	cout << "string(s0.begin(),s0.end()) daje: " << string(s0.begin(), s0.end()) << endl;

	system("pause.exe");
	return 0;
}
