#include <iostream>
#include <string>
using namespace std;

//prototip funkcija
char *funkcija1(char *niz);
string::iterator funkcija2(string::iterator pocetak, string::iterator kraj);
string::iterator funkcija3(string *s0);
int funkcija4(string *s0);

int main(void)
{
	string s0;
	char *slovo1; //deklaracija pokazivaca
	string::iterator slovo2, slovo3; //deklaracija iteratora
	int slovo4;

	cout << "Ucitaj recenicu do enter-a: " << endl;
	getline(cin, s0);

	slovo1 = funkcija1(&s0[0]);
	//naredba ispod nije dobra jer je s0 klasa, ne polje char-ova
	//slovo = funkcija(s0);

	if (slovo1 != nullptr) {
		cout << "Ispis od slova b, 1 nacin " << slovo1 << endl;
		cout << "Ispis slova b, 1 nacin " << *slovo1 << endl;
	}

	slovo2 = funkcija2(s0.begin(), s0.end());

	if (slovo2 != s0.end()) {
		cout << "Ispis od slova b, 2 nacin " << string(slovo2, s0.end()) << endl;
		cout << "Ispis slova b, 2 nacin " << *slovo2 << endl;
	}

	slovo3 = funkcija3(&s0);

	if (slovo3 != s0.end()) {
		cout << "Ispis od slova b, 3 nacin " << string(slovo3, s0.end()) << endl;
		cout << "Ispis slova b, 3 nacin " << *slovo3 << endl;
	}

	slovo4 = funkcija4(&s0);

	if (slovo4 != s0.length()) {
		cout << "Ispis od slova b, 4 nacin " << string(s0, slovo4, s0.length()-slovo4) << endl;
		cout << "Ispis slova b, 4 nacin " << s0.at(slovo4) << endl;
	}

	cin.get();
	return 0;
}

char *funkcija1(char *niz) {
	char *slovo1 = nullptr;
	int i = 0;

	while (niz[i] != '\0') {
		i++;
		if (niz[i] == 'b') {
			slovo1 = &niz[i];//ili slovo=niz+i;
			break;
		}

	}

	return slovo1;

}

string::iterator funkcija2(string::iterator pocetak, string::iterator kraj) {
	string::iterator it;
	//ne mozemo izjednaciti it sa nullptr

	for (it = pocetak; it < kraj; it++) {

		if (*it == 'b') { //dereferencirani it je vrijednost stringa na tom mjestu
			break;
		}

	}
	return it;
}

string::iterator funkcija3(string *s0) {
	string::iterator it;

	for (it = (*s0).begin(); it < (*s0).end(); it++) {

		if (*it == 'b') { //dereferencirani it je vrijednost stringa na tom mjestu
			break;
		}

	}
	return it;

}

int funkcija4(string *s0) {
	//string::iterator it;
	int i;

	for (i=0; i < (*s0).length(); i++) {

		if ((*s0).at(i) == 'b') { //ili (*s0)[i]
			break;
		}

	}
	return i;

}
