#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <string.h>

char *get_name(void); /* prototip funkcije. */

int main(void) {

	/* deklaracija pokazivaca na znakovni niz. */
	char *name = NULL;

	/* poziv funkcije. */
	name = get_name();

	/* ispis znakovnog niza. */
	if (name != NULL) {
		printf("Upisano ime je: %s", name);
	}
	else {
		printf("Alokacija nije uspjela");
	}

	/* oslobadanje memorije. */
	free(name);
	name = NULL;

	system("pause.exe");

	return 0;

} /* kraj main() funkcije. */


  /* funkcija koja vraca pokazivac na prvi element znakovnog niza. */
char *get_name(void) {

	/* alociraj memorijski blok od 100 bajta. */
	char *input = (char *) malloc(100);
	char *input2;

	/* provjeri da li je alokacija uspjela. */
	if (input == NULL) {
		printf("Nemoguce alocirati memoriju!\n");
		return NULL;
	}

	/* upit. */
	printf("Upisi svoje ime: ");

	/* spremanje u ulazni blok. */
	fgets(input, 100, stdin); //fgets cita do 99 znakova tj. posprema i \0


	printf("%d\n", strlen(input));

	/*realokacija na najmanju mogucu velicinu memorijskog bloka*/
	/*program bi radio i bez ovoga*/
	
	input2 = (char *) realloc(input, strlen(input)+1); //niz je duljine strlen+1 da bi pospremili i \0 znak tj. kraj niza
	
	/* provjeri da li je realokacija uspjela. */
	//ako nije uspjela realokacija, memorija na koju pokazuje input postoji i dalje!
	//ako je uspjela realokacija, realloc dealocira input tj. nije ga potrebno oslobadati
	if (input2 == NULL) {
		printf("Nemoguce realocirati memoriju!\n");
		
	}
	else {
		//sad input bude pokazivao na isto mjesto kao i input2
		input = input2;
	}

	/* vracanje adrese memorijskog bloka. */
	return input;

} /* kraj get_name() funkcije. */