#include <iostream>
#include <fstream>
#include <windows.h>
using namespace std;

int main() {
	streampos size;
	string data;
	int broj;
	char *memblock;
	int n = 0; int pow = 1; int i, j;
	ofstream outfile("example.bin", ios::binary);
	if (outfile.is_open())//provjera da li je uspjesno otvorena datoteka
	{
		//upis je ovdje drukciji od tekstualne datoteke
		cout << "Upisi prvi broj: ";
		cin >> broj;
		outfile.write((char *)&broj, sizeof(broj));

		cout << "Upisi drugi broj: ";
		cin >> broj;

		outfile.write((char *)&broj, sizeof(broj));
		outfile.close();
	}
	else cout << "Datoteka nije uspjesno otvorena" << endl;
	ifstream infile("example.bin", ios::binary | ios::ate);
	if (infile.is_open())//provjera da li je uspjesno otvorena datoteka
	{
		//ovo je primjer ucitavanja u dinamicko polje, nije da se to trebalo napraviti ako smo samo trebali
		//procitati iz datoteke 2 integer broja...
		//velicinu datoteke saznamo prego tellg, s obzirom da smo se pozicionirali na kraj (ios::ate)
		size = infile.tellg();
		//stvorimo dinamicko polje velicine datoteke
		memblock = new char[size];
		//postavimo se na pocetak datoteke
		infile.seekg(0, ios::beg);
		//pomocu read ucitamo u alocirani blok cijelu datoteku
		infile.read(memblock, size);
		infile.close();

		cout << "Cijeli sadrzaj datoteke je u memoriji" << endl;
		cout << "Ispis cijelog memorijskog bloka (neformatiran):" << endl;
		cout << memblock << endl;
		cout << "Ispis brojeva:" << endl;
		//ispis brojeva - kao integer - moramo 'znati' koja je vrsta podataka spremljena i na koji nacin
		for (j = 0;j <= size / sizeof(int) - 1;j++) {
			for (i = j*sizeof(int); i <= (j + 1)*sizeof(int) - 1; i++) {
				//pomocu casta (unsigned char) 'prisilim' da se znak prikazuje kao unsigned u rasponu 0-255
				n += (unsigned char)memblock[i] * pow;
				pow *= 256;
			}
			cout << n << endl;
			n = 0;pow = 1;
		}
		delete[] memblock;
	}
	else cout << "Datoteka nije uspjesno otvorena" << endl;
	system("pause.exe");
	return 0;
}