#include <stdio.h>
#include <windows.h>

int main(void) {

	/* deklaracija i inicijalizacija cjelobrojne varijable
	i cjelobrojne pokazivacke varijable. */
	int a = 456;
	int *x;

	/* pospremi adresu cjelobrojne varijable u cjelobrojnu 
	pokazivacku varijablu. */
	x = &a;

	/* Ispis vrijednosti pokazivacke varijable (adresa cjelobrojne varijable). */
	printf("Adresa od a: %p\n", x);

	/* Ispis vrijednosti cjelobrojne varijable. */
	printf("a na pocetku: %d\n", a);

	/* opet ispis vrijednosti cjelobrojne varijable,
	* ali ovaj puta pomocu dereferenciranja (upotrebom operatora *)
	* adrese pohranjene u pokazivackoj varijabli. */
	printf("*x na pocetku: %d\n\n", *x);

	/* Promijeni vrijednost cjelobrojne varijable
	* pomou dereferenciranja adrese pohranjene u cjelobrojnoj
	* pokazivackoj varijabli. */
	*x = 123;

	/* ispis izmijenjene vrijednosti 
	* izravnom upotrebom imena varijable te
	* neizravnom upotrebom operatora adrese i dereferenciranja. */
	printf("a na kraju:   %d\n", a);
	printf("*x na kraju:   %d\n", *x);

	system("pause.exe");

	return 0;

}