#include <stdio.h>
#include <windows.h>
#include <math.h> 
#include <string.h>
#include <ctype.h>

int pretvorba(char *niz, int broj_clana);

int main(int argc, char *argv[]) {

	/* deklaracija varijable i za for petlju. */
	int i;
	int sum = 0; /*pocetna suma*/

	for (i = 1; i < argc; i++) {
		sum = sum + pretvorba(argv[i],i);
	}

	printf("Suma svih upisanih brojeva je %d\n", sum);
	system("pause.exe");

	return 0;

}

int pretvorba(char *niz, int broj_clana) {
	
	int pocetak = 0; //od kojeg clana niza pocinjem konverziju
	int i;
	float broj=0; //ovo vracam kao rezultat

	if (niz[0] == '-') {
		pocetak = 1; //ako je broj negativan, pocinjem od sljedeceg clana
	}

	for (i = pocetak; i < strlen(niz);i++) {
		if (isdigit(niz[i]) == 0) {//provjera da li su svi clanovi znakovnog niza brojevi
			printf("Clan %d upisanog niza nije cijeli broj\n", broj_clana);
			return 0;
		}
		else {
			broj = broj + (niz[i] - 48)*pow(10, strlen(niz) - i - 1);//karakter 0 je na 48 mjestu ASCII tablice
		}
		
	}

	if (pocetak == 1) {
		broj = -broj;
	}

	return (int) broj;
}