#include <iostream>
#include <windows.h>
#include <iomanip>
#include <stdlib.h>
#include <time.h>
using namespace std;

int* matrica(int a, int b);

int main(void) {

	int* mat = NULL;
	int i, j; // varijabla za for petlju.
	int a, b; // stvarna velicina polja
	
	// Upit za korisnika.
	cout << "Upisi broj redaka: ";
	cin >> a;
	cout << "Upisi broj stupaca: ";
	cin >> b;

	mat = matrica(a, b);

	cout << "Ispis matrice: " << endl;
	//ispisujemo matricu po recima, pa po stupcima, jer je tako lakse
	//setfill i setw su od <iomanip> i sluze samo za ljepsi ispis...
	//ne bi ih se trebalo koristiti u programu...
	for (i = 0; i < a; i++) {
		for (j = 0; j < b;j++) {
			cout << setfill('0') << setw(3) << mat[j*a + i] << " ";

		}
		cout << endl;
	}

	delete[] mat;
	system("pause.exe");
	return 0;
}

int* matrica(int a, int b) {
	int i, j, temp;
	int* mat = new int[a*b];
	
	/* Inicijalizacija generatora slucajnih brojeva */
	srand(time(NULL));
	//popunjavamo prvo po stupcima pa po recima
	for (i = 0; i < b; i++) {
		for (j = 0; j < a;j++) {
			mat[i*a + j]= rand() % 1000; //ili *(mat+i*a+j)
		}
	}

	//sort matrice po stupcima, pa po recima
	// s obzirom da je matrica napravljena kao 1D polje stupaca
	// tako je i sortiramo (kao obican 1D niz) 
	for (i = 0;i < a*b;i++) {
		for (j = i + 1;j < a*b;j++) {
			if (mat[i]>mat[j]) {
				//zamijeni mjesta mat[i] i mat[j]
				temp = mat[j];
				mat[j] = mat[i];
				mat[i] = temp;
			}
		}

		}
	return mat;
}