#include <iostream>
#include <iomanip>
#include <stdlib.h>
#include <windows.h>
#include <time.h>
using namespace std;

int* matrica(int a, int b);

int main(void) {

	int* mat = NULL;
	int i, j; // varijabla za for petlju.
	int a, b; // stvarna velicina polja

	// Upit za korisnika.
	cout << "Upisi broj redaka: ";
	cin >> a;
	cout << "Upisi broj stupaca: ";
	cin >> b;

	mat = matrica(a, b);

	cout << "Ispis matrice: " << endl;
	for (i = 0; i < a; i++) {
		for (j = 0; j < b;j++) {
			//setfill i setw nije bitan za zadatak, vec za ljepsi prikaz
			//koristi direktivu <iomanip>
			cout << setfill('0') << setw(3) << mat[i*b+j] << " ";
		}
		cout << endl;
	}

	delete[] mat;
	system("pause.exe");
	return 0;
}

int* matrica(int a, int b) {
	int i, j, temp;
	int* mat = new int[a*b];

	/* Inicijalizacija generatora slucajnih brojeva */
	srand(time(NULL));
	//popunjavamo matricu tako  da imamo 1D niz redaka
	for (i = 0; i < a; i++) {
		for (j = 0; j < b;j++) {
			mat[i*b+j] = rand() % 1000; //ili *(mat+i*b+j)
		}
	}

	// sort matrice po recima, pa po stupcima
	// s obzirom da je matrica napravljena kao 1D polje niza redaka
	// tako je i sortiramo (kao obicni 1D niz)
	for (i = 0;i < a*b;i++) {
		for (j = i + 1;j < a*b;j++) {
			if (mat[i]>mat[j]) {
				//zamijeni mjesta mat[i] i mat[j]
				temp = mat[j];
				mat[j] = mat[i];
				mat[i] = temp;
			}
		}

	}
	return mat;
}